#ifndef _AICOMMON  
#define _AICOMMON

#include "Keys.h"
#include "Remap.h"

#define kScreenDepth					16
#define kMaskDepth						1

	// terrain
	#define							kGround										1
	#define							kWater										2
	#define							kBridge										3
	#define							kRed											4

	// entities
	#define							kMaxEntities							20
	
	#define							kHuman										1
	#define							kTroll										2
	#define							kTree											3

	#define							kEntitySpeed							30
	#define							kPlayerSpeed							4

	// entity states
	#define							kPlayer										1
	#define							kStatic										2
	#define							kPatrolling								3
	#define							kChasing									4
	#define							kPatrollingChasing				5
	#define							kPatternMovement					6

	#define							kChaseDistance						7
	#define							kMaxPathLength						200

	// world constants
	#define							kMaxRows									20
	#define							kMaxCols									30
	#define							kMaxTiles									10

	// world constants
	#define							kUpKey										1
	#define							kDownKey									2
	#define							kLeftKey									3
	#define							kRightKey									4

class	ai_Entity
{
	public:
	int												row;
	int												col;
	int												type;
	int												state;
	int												startRow;
	int												startCol;
	int												endRow;
	int												endCol;
	int												target;
	int												pathRow[kMaxPathLength];
	int												pathCol[kMaxPathLength];
	int												pathSize;
	int												pathRowTarget;
	int												pathColTarget;
	int												patternRowOffset;
	int												patternColOffset;
	int												nextStep;
	unsigned long							timeToMove;
	
	ai_Entity();
	~ai_Entity();
	
	void InitializePathArrays		(void);
	void BuildPathSegment				(int startingRow, int startingCol, int endingRow, int endingCol);
	void FollowPattern					(void);
	void ShowPath								(void);
	void New										(int theType, int theState, int theStartRow, int theStartCol, int theEndRow, int theEndCol);
  void NormalizePattern				(void);

};
//--------------------------------------------------------------
class	ai_World
{
	public:

	TBoolean									showPath;
	
	ai_World();
	~ai_World();
	void Redraw						(void);
	void UpdateWorld			(void);
	void KeyDown					(int key);

};

#endif