#ifndef _AICOMMON  
#define _AICOMMON

#include "Keys.h"
#include "Remap.h"

#define kScreenDepth					16
#define kMaskDepth						1

	// terrain
	#define							kGround										1
	#define							kWater										2
	#define							kBridge										3
	#define							kCrump1										4
	#define							kCrump2										5
	#define							kCrump3										6
	#define							kCrump4										7
	#define							kCrump5										8
	#define							kCrump6										9
	#define							kCrump7										10
	#define							kCrump8										11
	#define							kCrump9										12
	#define							kCrump10									13
	#define							kCrump11									14
	#define							kCrump12									15
	#define							kCrump13									16
	#define							kCrump14									17
	#define							kCrump15									18

	// entities
	#define							kMaxEntities							20
	
	#define							kHuman										1
	#define							kTroll										2
	#define							kTree											3

	#define							kEntitySpeed							30
	#define							kPlayerSpeed							4

	// entity states
	#define							kPlayer										1
	#define							kStatic										2
	#define							kPatrolling								3
	#define							kChasing									4
	#define							kPatrollingChasing				5

	#define							kChaseDistance						7
	#define							kMaxPathLength						30
	#define							kMaxTrailLength						15

	// world constants
	#define							kMaxRows									20
	#define							kMaxCols									30
	#define							kMaxTiles									20

	// world constants
	#define							kUpKey										1
	#define							kDownKey									2
	#define							kLeftKey									3
	#define							kRightKey									4

class	ai_Entity
{
	public:
	int												row;
	int												col;
	int												type;
	int												state;
	int												startRow;
	int												startCol;
	int												endRow;
	int												endCol;
	int												target;
	int												pathRow[kMaxPathLength];
	int												pathCol[kMaxPathLength];
	int												trailRow[kMaxTrailLength];
	int												trailCol[kMaxTrailLength];
	int												pathRowTarget;
	int												pathColTarget;
	int												pathPtr;
	unsigned long							timeToMove;
	
	ai_Entity();
	~ai_Entity();
	
	void New										(int theType, int theState, int theStartRow, int theStartCol, int theEndRow, int theEndCol);

};

//--------------------------------------------------------------

class	ai_World
{
	public:

	TBoolean									showPath;
	
	ai_World();
	~ai_World();
	void Redraw						(void);
	void UpdateWorld			(void);
	void KeyDown					(int key);
	void DropBreadCrump		(void);

};

#endif